SystemOrganization addCategory: #'Wiimote-Etoys'!
SystemOrganization addCategory: #'Wiimote-Core'!
SystemOrganization addCategory: #'Wiimote-Errors'!
SystemOrganization addCategory: #'Wiimote-FFI'!

Player subclass: #WiimotePlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-Etoys'!

!WiimotePlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:29'!
isUniClass
	^ self ~~ self officialClass! !

!WiimotePlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:29'!
officialClass
	^ WiimotePlayer! !

!WiimotePlayer class methodsFor: 'as yet unclassified' stamp: 'Richo 2/11/2010 17:29'!
wantsChangeSetLogging
	"Log changes for Player itself, but not for automatically-created subclasses like Player1, Player2, but *do* log it for uniclasses that have been manually renamed."

	^ (self == self officialClass or:
		[(self name beginsWith: self officialClass asString) not]) or:
			[Preferences universalTiles]! !

!WiimotePlayer methodsFor: 'commands' stamp: 'Richo 12/1/2009 14:25'!
connect
^ self costume renderedMorph connect! !

!WiimotePlayer methodsFor: 'commands' stamp: 'Richo 12/1/2009 13:41'!
disconnect
^ self costume renderedMorph disconnect! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:19'!
getAccelX
^ self costume renderedMorph accelX! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:19'!
getAccelY
^ self costume renderedMorph accelY! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:19'!
getAccelZ
^ self costume renderedMorph accelZ! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getBatteryLevel
^ self costume renderedMorph batteryLevel! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonA
^ self costume renderedMorph buttonA! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonB
^ self costume renderedMorph buttonB! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonDown
^ self costume renderedMorph buttonDown! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonHome
^ self costume renderedMorph buttonHome! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonLeft
^ self costume renderedMorph buttonLeft! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonMinus
^ self costume renderedMorph buttonMinus! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonOne
^ self costume renderedMorph buttonOne! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonPlus
^ self costume renderedMorph buttonPlus! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonRight
^ self costume renderedMorph buttonRight! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonTwo
^ self costume renderedMorph buttonTwo! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 16:07'!
getButtonUp
^ self costume renderedMorph buttonUp! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:42'!
getIrSensitivity
^ self costume renderedMorph irSensitivity ! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getIsConnected
^ self costume renderedMorph isConnected! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getIsUsingAccelerometer
^ self costume renderedMorph isUsingAccelerometer! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:24'!
getIsUsingIR
^ self costume renderedMorph isUsingIR ! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:06'!
getIsVisibleIR1
^ self costume renderedMorph isVisibleIR: 1! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:06'!
getIsVisibleIR2
^ self costume renderedMorph isVisibleIR: 2! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:06'!
getIsVisibleIR3
^ self costume renderedMorph isVisibleIR: 3! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:06'!
getIsVisibleIR4
^ self costume renderedMorph isVisibleIR: 4! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getLed1
^ self costume renderedMorph led1! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getLed2
^ self costume renderedMorph led2! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getLed3
^ self costume renderedMorph led3! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
getLed4
^ self costume renderedMorph led4! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/7/2009 17:01'!
getOrientPitch
^ self costume renderedMorph pitch! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/7/2009 17:01'!
getOrientRoll
^ self costume renderedMorph roll! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/7/2009 17:01'!
getOrientYaw
^ self costume renderedMorph yaw! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 14:32'!
getRumble
^ self costume renderedMorph rumble! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/2/2009 14:44'!
getSizeIR1
^ self costume renderedMorph sizeIR: 1! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/2/2009 14:44'!
getSizeIR2
^ self costume renderedMorph sizeIR: 2! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/2/2009 14:44'!
getSizeIR3
^ self costume renderedMorph sizeIR: 3! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/2/2009 14:44'!
getSizeIR4
^ self costume renderedMorph sizeIR: 4! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 14:22'!
getWiimoteNumber
^ self costume renderedMorph wiimoteNumber! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getXIR1
^ self costume renderedMorph xIR: 1! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getXIR2
^ self costume renderedMorph xIR: 2! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getXIR3
^ self costume renderedMorph xIR: 3! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getXIR4
^ self costume renderedMorph xIR: 4! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getYIR1
^ self costume renderedMorph yIR: 1! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getYIR2
^ self costume renderedMorph yIR: 2! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getYIR3
^ self costume renderedMorph yIR: 3! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:04'!
getYIR4
^ self costume renderedMorph yIR: 4! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:42'!
setIrSensitivity: aNumber
^ self costume renderedMorph irSensitivity: aNumber! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:48'!
setIsUsingAccelerometer: aBoolean
^ self costume renderedMorph isUsingAccelerometer: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 17:24'!
setIsUsingIR: aBoolean
^ self costume renderedMorph isUsingIR: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
setLed1: aBoolean
^ self costume renderedMorph led1: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
setLed2: aBoolean
^ self costume renderedMorph led2: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
setLed3: aBoolean
^ self costume renderedMorph led3: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 13:41'!
setLed4: aBoolean
^ self costume renderedMorph led4: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 14:32'!
setRumble: aBoolean
^ self costume renderedMorph rumble: aBoolean! !

!WiimotePlayer methodsFor: 'slots' stamp: 'Richo 12/1/2009 14:22'!
setWiimoteNumber: aNumber
^ self costume renderedMorph wiimoteNumber: aNumber! !

Morph subclass: #WiimoteMorph
	instanceVariableNames: 'etoy wiimoteNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-Etoys'!

WiimoteMorph class
	instanceVariableNames: 'form'!

WiimoteMorph class
	instanceVariableNames: 'form'!

!WiimoteMorph class methodsFor: 'viewer categories' stamp: 'Richo 4/12/2011 17:07'!
additionsToViewerCategories
^ #(
(#'wiimote-connection' (
#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot batteryLevel 'Shows the battery level of the Wiimote' Number readOnly Player getBatteryLevel Player unused )
#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
#(slot wiimoteNumber 'Shows the number which corresponds to this Wiimote' Number readWrite Player getWiimoteNumber Player setWiimoteNumber:)
))

(#'wiimote-leds and rumble' (
#(slot led1 'You can turn on/off the first led of this Wiimote' Boolean readWrite Player getLed1 Player setLed1:  )
#(slot led2 'You can turn on/off the second led of this Wiimote' Boolean readWrite Player getLed2 Player setLed2:  )
#(slot led3 'You can turn on/off the third led of this Wiimote' Boolean readWrite Player getLed3 Player setLed3:  )
#(slot led4 'You can turn on/off the fourth led of this Wiimote' Boolean readWrite Player getLed4 Player setLed4:  )
#(slot rumble 'You can turn on/off the vibration of this Wiimote' Boolean readWrite Player getRumble Player setRumble:  )
))

(#'wiimote-orient' (
#(slot isUsingAccelerometer 'Inidicates if this Wiimote is using its accelerometer' Boolean readWrite Player getIsUsingAccelerometer Player setIsUsingAccelerometer: )
#(slot pitch 'Shows the pitch value of this Wiimote' Number readOnly Player getOrientPitch Player unused )
#(slot roll 'Shows the roll value of this Wiimote' Number readOnly Player getOrientRoll Player unused )
#(slot yaw 'Shows the yaw value of this Wiimote' Number readOnly Player getOrientYaw Player unused )
#(slot accelX 'Shows the acceleration of this Wiimote along the x axis' Number readOnly Player getAccelX Player unused )
#(slot accelY 'Shows the acceleration of this Wiimote along the y axis' Number readOnly Player getAccelY Player unused )
#(slot accelZ 'Shows the acceleration of this Wiimote along the z axis' Number readOnly Player getAccelZ Player unused )
))

(#'wiimote-buttons'
(
#(slot buttonA 'Indicates if button A is pressed' Boolean readOnly Player getButtonA unused unused)
#(slot buttonB 'Indicates if button B is pressed' Boolean readOnly Player getButtonB unused unused)
#(slot buttonUp 'Indicates if button up is pressed' Boolean readOnly Player getButtonUp unused unused)
#(slot buttonDown 'Indicates if button down is pressed' Boolean readOnly Player getButtonDown unused unused)
#(slot buttonLeft 'Indicates if button left is pressed' Boolean readOnly Player getButtonLeft unused unused)
#(slot buttonRight 'Indicates if button right is pressed' Boolean readOnly Player getButtonRight unused unused)
#(slot buttonMinus 'Indicates if button minus is pressed' Boolean readOnly Player getButtonMinus unused unused)
#(slot buttonPlus 'Indicates if button plus is pressed' Boolean readOnly Player getButtonPlus unused unused)
#(slot buttonHome 'Indicates if button home is pressed' Boolean readOnly Player getButtonHome unused unused)
#(slot buttonOne 'Indicates if button one is pressed' Boolean readOnly Player getButtonOne unused unused)
#(slot buttonTwo 'Indicates if button two is pressed' Boolean readOnly Player getButtonTwo unused unused)
))

(#'wiimote-ir'
(
#(slot isUsingIr 'You can turn on/off its infrared cam' Boolean readWrite Player getIsUsingIR Player setIsUsingIR: )
#(slot irSensitivity 'Shows the ir sensitivity' Boolean readWrite Player getIrSensitivity Player setIrSensitivity: )

#(slot #'ir 1 - x' 'Shows the coordinates of led 1 along the x axis' Number readOnly Player getXIR1 Player unused)
#(slot #'ir 1 - y' 'Shows the coordinates of led 1 along the y axis' Number readOnly Player getYIR1 Player unused)
#(slot #'ir 1 - size' 'Shows the size of led 1' Number readOnly Player getSizeIR1 Player unused)

#(slot #'ir 2 - x' 'Shows the coordinates of led 2 along the x axis' Number readOnly Player getXIR2 Player unused)
#(slot #'ir 2 - y' 'Shows the coordinates of led 2 along the y axis' Number readOnly Player getYIR2 Player unused)
#(slot #'ir 2 - size' 'Shows the size of led 2' Number readOnly Player getSizeIR2 Player unused)

#(slot #'ir 3 - x' 'Shows the coordinates of led 3 along the x axis' Number readOnly Player getXIR3 Player unused)
#(slot #'ir 3 - y' 'Shows the coordinates of led 3 along the y axis' Number readOnly Player getYIR3 Player unused)
#(slot #'ir 3 - size' 'Shows the size of led 3' Number readOnly Player getSizeIR3 Player unused)

#(slot #'ir 4 - x' 'Shows the coordinates of led 4 along the x axis' Number readOnly Player getXIR4 Player unused)
#(slot #'ir 4 - y' 'Shows the coordinates of led 4 along the y axis' Number readOnly Player getYIR4 Player unused)
#(slot #'ir 4 - size' 'Shows the size of led 4' Number readOnly Player getSizeIR4 Player unused)

#(slot #'ir 1 - isVisible' 'Indicates if led 1 is visible' Boolean readOnly Player getIsVisibleIR1 Player unused)
#(slot #'ir 2 - isVisible' 'Indicates if led 2 is visible' Boolean readOnly Player getIsVisibleIR2 Player unused)
#(slot #'ir 3 - isVisible' 'Indicates if led 3 is visible' Boolean readOnly Player getIsVisibleIR3 Player unused)
#(slot #'ir 4 - isVisible' 'Indicates if led 4 is visible' Boolean readOnly Player getIsVisibleIR4 Player unused)
))

)

! !

!WiimoteMorph class methodsFor: 'parts bin' stamp: 'Richo 12/26/2012 17:51'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'Wiimote' translatedNoop
		categories: (Project current isPEProject
						ifTrue: [{'Physical Etoys' translatedNoop}]
						ifFalse: [#()])
		documentation: 'An object that you can use to access the info from a wiimote joystick' translatedNoop
	! !

!WiimoteMorph class methodsFor: 'form' stamp: 'Richo 12/2/2009 17:31'!
form
^form ifNil: [self initializeForm]! !

!WiimoteMorph class methodsFor: 'parts bin' stamp: 'Richo 12/2/2009 17:59'!
includeInNewMorphMenu
	^true! !

!WiimoteMorph class methodsFor: 'form' stamp: 'Richo 12/2/2009 17:31'!
initializeForm
^form := PEUtilities formFromEncodedPNG:  'iVBORw0KGgoAAAANSUhEUgAAACsAAAC1CAYAAADGMQbzAAAE1UlEQVR4XuWdoXbqQBCGkTxC
JbISieQxKpHISiSyshKJRFYikZWVyEpkZV1u/yWTs927u9kkm2TSv+fMIQRIP4bJzOzOTjKL
/BUjSvJfsVqtit1uN5rg/6dAF+fzufj+/h5dwBEDNt9KA6gIeHzAQY26P9HQmv9Pw7AR3xuX
y5UXfmgNlzYc1mq1D4/4MoAsQYcGtrUb/PnNtg0K+fngGNpNh4V2IVphfwngBHoku62F9Z14
Y7m3JM3acDD0sYJGuhkokCDs5XIprter0SIeIR8fH0bw2vv7++AaDsK+vLxUMIfDwcjxeDSC
7be3t2K73erRLB5Pp5MBg0ahTTziOb7I7XYzwm+zfcKey0AREzWw91RuHhVVsDHtqYZ1817V
sIBzn/PD/gnYuqFzHWzs8ymhuxFsnWuqO8FSP5sNto9clh9WDuoLrXU2Fwu//LD8NtsnbFv3
M7jr6jMo8OcG/LD8yfdfGtZMZsA4qaE4/4wMPyw/LD8sP2z/QeFeX/VHr1BteBRYAXUTGIls
OYA7w4pGU0DkfW2rPJ1hm2rMHf4MDttEU/dS/Hx4WBko+l5DSQqSU7udYUP/dLlcFo+Pj60S
9UFhUYUE6GKxKL6+vvTDovL4+flpqpIqYNueLE1PyqzeoImWYidl77ASuVI0Jb/EaH7Wjky5
A8ggQ3F70aWd3HRdTJE1RbSTFnc6M8eqD/7kmx+WH5Yflh+WH5Yflh+WH5Yflh+WH7Zln0LT
FRd2tbFNKTU0qIzC2hPE9uAvBuGOt+qg5Zj2IDMEHISVg4TG/qEuJ9m/g3bL7VAjhnss+9EH
HISNaTCkLdkHyBk0BC1fr8EWF98aBdc0GsG61e5UWFuzKbDugrbGsCFDD00Gyz5oMxXW/h/2
e3xmGIT1fbO6mcOYbYYmOXz2H5oTq21e83mD2OyKazp1LVn22W97A99nav2sz2b7almtW4TJ
G25RncHUvFRq0N2E59DW6+ur2VYDi7Ys1BOupW/dbDYGFND7/b5zh1NWWBQ7AIT2LBE8x37Z
5s+6+GH5Yflh+WHbC9pcpQqOaCV+1TQZd4xe2WHvIfVWJUASXiVA8JsBBezDw6JaDLFarX8S
mGOV4Dw/P/NrlgP26Wnz4wUuVS6Lbn1s7/cv+haow3WJbz2d7pcZEDfmW9jDbwapstlsK23i
7JcVc3iEKaiCxcIzGUbfXdehcl2wYVWwyAskNzDbnv38Ntsugj1UZz1cFX7++/ZenxnwR7D+
gsKhuJUnklx7RvJZiWx6vIG1jUhmewZ+M+CH5Yflh+WHzXdQu8KT89Ju2Vcmh/rBVK1MlmJb
SvV7dNg6mC7dSllhpYHNLTOhtyZH50dWWF+pFNOcPtgu8we9weKaifP5/FftSwWszwxyNgDx
nmDugoZQK6u6dpVJBIXJhVv+rIsfdoqwbnddl97w3v2s22VvX/dA1fUNYiE3tSlz8NwA00VI
EWXKU3WKiEwLk3LunKzaFBEV8fV6rR8WoGKj9io5FbACkuM9g3qD0Og2h7/NGhR8K+PtffwR
jD+R4Yflhx0YdrYvjIz1ejKsOdCsFM8B+37978JOygz4vQE/LD8sPyw/LD+sXlgt9wuNT/yV
d7nMMfrsU+w7XKrWbujurJO5K+vk7nc7uTsJq75H8z/ZO2OTS9kQwwAAAABJRU5ErkJggg=='! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 17:18'!
accelX
^[etoy accelX] on: WiimoteError do: [-1].! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 17:18'!
accelY
^[etoy accelY] on: WiimoteError do: [-1].! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 17:18'!
accelZ
^[etoy accelZ] on: WiimoteError do: [-1].! !

!WiimoteMorph methodsFor: 'connection' stamp: 'Richo 12/1/2009 13:47'!
batteryLevel
^[ etoy batteryLevel] on: WiimoteError do: [-1]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:05'!
buttonA
^[etoy buttonA] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:05'!
buttonB
^[etoy buttonB] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:05'!
buttonDown
^[etoy buttonDown] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:06'!
buttonHome
^[etoy buttonHome] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:05'!
buttonLeft
^[etoy buttonLeft] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:06'!
buttonMinus
^[etoy buttonMinus] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:06'!
buttonOne
^[etoy buttonOne] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:06'!
buttonPlus
^[etoy buttonPlus] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:05'!
buttonRight
^[etoy buttonRight] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:06'!
buttonTwo
^[etoy buttonTwo] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'buttons' stamp: 'Richo 12/1/2009 16:05'!
buttonUp
^[etoy buttonUp] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:55'!
connect
	self isConnected
		ifFalse: [^ [etoy connect: wiimoteNumber]
				on: WiimoteError 
				do: [:err | self inform: err description]]! !

!WiimoteMorph methodsFor: 'initialize-release' stamp: 'Richo 12/1/2009 13:45'!
delete
self disconnect.
super delete! !

!WiimoteMorph methodsFor: 'connection' stamp: 'Richo 12/1/2009 13:46'!
disconnect
self isConnected 
	ifTrue: [etoy disconnect]! !

!WiimoteMorph methodsFor: 'drawing' stamp: 'Richo 12/2/2009 17:32'!
drawOn: aCanvas
aCanvas translucentImage: self class form at: self bounds topLeft! !

!WiimoteMorph methodsFor: 'filter viewer' stamp: 'Richo 12/22/2009 17:05'!
filterViewerCategoryDictionary: dict
| validCategories |
super filterViewerCategoryDictionary: dict.
validCategories := self validCategories.
dict keys do: [:each|
	(validCategories includes: each)
		ifFalse: [
			dict removeKey: each
			].
	]! !

!WiimoteMorph methodsFor: 'initialize-release' stamp: 'Richo 12/2/2009 17:32'!
initialize
super initialize. 
self extent: self class form extent.
etoy := Wiimote new.
wiimoteNumber := 1.! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:42'!
irSensitivity
^[etoy irSensitivity] on: WiimoteError do: [0]! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:42'!
irSensitivity: aNumber
[etoy irSensitivity: aNumber] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'connection' stamp: 'Richo 12/1/2009 13:41'!
isConnected
^ etoy isConnected! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 13:43'!
isUsingAccelerometer
^[ etoy isUsingAccelerometer] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 13:51'!
isUsingAccelerometer: aBoolean
[ etoy useAccelerometer: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:23'!
isUsingIR
^[etoy isUsingIR] on: WiimoteError do: [false]
! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:23'!
isUsingIR: aBoolean
[etoy useIR: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:05'!
isVisibleIR: irNumber
^[etoy isVisibleIR: irNumber] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:47'!
led1
^ [etoy led1] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:48'!
led1: aBoolean
^ [etoy led1: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:47'!
led2
^ [etoy led2] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:48'!
led2: aBoolean
^ [etoy led2: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:47'!
led3
^ [etoy led3] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:48'!
led3: aBoolean
^ [etoy led3: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:47'!
led4
^ [etoy led4] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'leds' stamp: 'Richo 12/1/2009 13:48'!
led4: aBoolean
^ [etoy led4: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'initialize-release' stamp: 'Richo 12/1/2009 13:41'!
newPlayerInstance
^ WiimotePlayer newUserInstance! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 13:47'!
pitch
^[ etoy pitch] on: WiimoteError do: [-1]! !

!WiimoteMorph methodsFor: 'fileOut' stamp: 'Richo 2/16/2010 11:20'!
prepareToBeSaved
	super prepareToBeSaved.
	self disconnect! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 13:47'!
roll
^ [etoy roll] on: WiimoteError do: [-1]! !

!WiimoteMorph methodsFor: 'leds and rumble' stamp: 'Richo 12/1/2009 14:32'!
rumble
^[etoy rumble] on: WiimoteError do: [false]! !

!WiimoteMorph methodsFor: 'leds and rumble' stamp: 'Richo 12/1/2009 14:32'!
rumble: aBoolean
[etoy rumble: aBoolean] on: WiimoteError do: []! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/2/2009 14:43'!
sizeIR: irNumber
^[etoy sizeIR: irNumber] on: WiimoteError do: [-1]! !

!WiimoteMorph methodsFor: 'filter viewer' stamp: 'Richo 12/22/2009 17:05'!
validCategories
^self class additionsToViewerCategories collect: [:each| each first]! !

!WiimoteMorph methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:25'!
wiimoteNumber
^wiimoteNumber ! !

!WiimoteMorph methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:25'!
wiimoteNumber: aNumber
self isConnected ifTrue: [^self].
(aNumber between: 1 and: Wiiuse maxWiimotes) ifFalse: [^self].
wiimoteNumber := aNumber ! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:05'!
xIR: irNumber
^[etoy xIR: irNumber] on: WiimoteError do: [-1]! !

!WiimoteMorph methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:05'!
yIR: irNumber
^[etoy yIR: irNumber] on: WiimoteError do: [-1]! !

!WiimoteMorph methodsFor: 'orient' stamp: 'Richo 12/1/2009 13:48'!
yaw
^ [etoy yaw] on: WiimoteError do: [-1]! !

ExternalStructure subclass: #WiiuseStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

WiiuseStructure subclass: #AccelStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!AccelStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/30/2009 16:09'!
fields
"AccelStructure defineFields"
	^ #(
	#(#calZero 'Vec3bStructure') 
	#(#calG 'Vec3bStructure') 
	#(#fakeByte1 'byte')
	#(#fakeByte2 'byte')
	#(#stRoll 'float') 
	#(#stPitch 'float') 
	#(#stAlpha 'float')
	 )! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
calG
	"This method was automatically generated"
	^Vec3bStructure fromHandle: (handle structAt: 4 length: 3)! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
calG: anObject
	"This method was automatically generated"
	handle structAt: 4 put: anObject getHandle length: 3.! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
calZero
	"This method was automatically generated"
	^Vec3bStructure fromHandle: (handle structAt: 1 length: 3)! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
calZero: anObject
	"This method was automatically generated"
	handle structAt: 1 put: anObject getHandle length: 3.! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1
	"This method was automatically generated"
	^handle unsignedByteAt: 7! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 7 put: anObject! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2
	"This method was automatically generated"
	^handle unsignedByteAt: 8! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 8 put: anObject! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stAlpha
	"This method was automatically generated"
	^handle floatAt: 17! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stAlpha: anObject
	"This method was automatically generated"
	handle floatAt: 17 put: anObject! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stPitch
	"This method was automatically generated"
	^handle floatAt: 13! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stPitch: anObject
	"This method was automatically generated"
	handle floatAt: 13 put: anObject! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stRoll
	"This method was automatically generated"
	^handle floatAt: 9! !

!AccelStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stRoll: anObject
	"This method was automatically generated"
	handle floatAt: 9 put: anObject! !

WiiuseStructure subclass: #ClassicCtrlStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!ClassicCtrlStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 17:05'!
fields
"ClassicCtrlStructure defineFields"
	^ #(
	#(#btns 'short') 
	#(#btnsHeld 'short') 
	#(#btnsReleased 'short') 
	#(#rShoulder 'float') 
	#(#lShoulder 'float') 
	#(#ljs 'JoystickStructure') 
	#(#rjs 'JoystickStructure') 
	)! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns
	"This method was automatically generated"
	^handle signedShortAt: 1! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns: anObject
	"This method was automatically generated"
	handle signedShortAt: 1 put: anObject! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld
	"This method was automatically generated"
	^handle signedShortAt: 3! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld: anObject
	"This method was automatically generated"
	handle signedShortAt: 3 put: anObject! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased
	"This method was automatically generated"
	^handle signedShortAt: 5! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased: anObject
	"This method was automatically generated"
	handle signedShortAt: 5 put: anObject! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
lShoulder
	"This method was automatically generated"
	^handle floatAt: 11! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
lShoulder: anObject
	"This method was automatically generated"
	handle floatAt: 11 put: anObject! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ljs
	"This method was automatically generated"
	^JoystickStructure fromHandle: (handle structAt: 15 length: 14)! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ljs: anObject
	"This method was automatically generated"
	handle structAt: 15 put: anObject getHandle length: 14.! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
rShoulder
	"This method was automatically generated"
	^handle floatAt: 7! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
rShoulder: anObject
	"This method was automatically generated"
	handle floatAt: 7 put: anObject! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
rjs
	"This method was automatically generated"
	^JoystickStructure fromHandle: (handle structAt: 29 length: 14)! !

!ClassicCtrlStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
rjs: anObject
	"This method was automatically generated"
	handle structAt: 29 put: anObject getHandle length: 14.! !

WiiuseStructure subclass: #EventBufStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!EventBufStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 17:23'!
fields
"EventBufStructure defineFields"
	^ #(
	#(#event1 'char') 
	#(#event2 'char') 
	#(#event3 'char') 
	#(#event4 'char') 
	#(#event5 'char') 
	#(#event6 'char') 
	#(#event7 'char') 
	#(#event8 'char') 
	#(#event9 'char') 
	#(#event10 'char') 
	#(#event11 'char') 
	#(#event12 'char') 
	#(#event13 'char') 
	#(#event14 'char') 
	#(#event15 'char') 
	#(#event16 'char') 
	#(#event17 'char') 
	#(#event18 'char') 
	#(#event19 'char') 
	#(#event20 'char') 
	#(#event21 'char') 
	#(#event22 'char') 
	#(#event23 'char') 
	#(#event24 'char') 
	#(#event25 'char') 
	#(#event26 'char') 
	#(#event27 'char') 
	#(#event28 'char') 
	#(#event29 'char') 
	#(#event30 'char') 
	#(#event31 'char') 
	#(#event32 'char') 
	)! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event1
	"This method was automatically generated"
	^handle unsignedCharAt: 1! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event10
	"This method was automatically generated"
	^handle unsignedCharAt: 10! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event10: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 10 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event11
	"This method was automatically generated"
	^handle unsignedCharAt: 11! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event11: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 11 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event12
	"This method was automatically generated"
	^handle unsignedCharAt: 12! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event12: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 12 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event13
	"This method was automatically generated"
	^handle unsignedCharAt: 13! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event13: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 13 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event14
	"This method was automatically generated"
	^handle unsignedCharAt: 14! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event14: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 14 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event15
	"This method was automatically generated"
	^handle unsignedCharAt: 15! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event15: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 15 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event16
	"This method was automatically generated"
	^handle unsignedCharAt: 16! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event16: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 16 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event17
	"This method was automatically generated"
	^handle unsignedCharAt: 17! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event17: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 17 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event18
	"This method was automatically generated"
	^handle unsignedCharAt: 18! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event18: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 18 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event19
	"This method was automatically generated"
	^handle unsignedCharAt: 19! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event19: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 19 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event1: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 1 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event2
	"This method was automatically generated"
	^handle unsignedCharAt: 2! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event20
	"This method was automatically generated"
	^handle unsignedCharAt: 20! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event20: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 20 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event21
	"This method was automatically generated"
	^handle unsignedCharAt: 21! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event21: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 21 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event22
	"This method was automatically generated"
	^handle unsignedCharAt: 22! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event22: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 22 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event23
	"This method was automatically generated"
	^handle unsignedCharAt: 23! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event23: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 23 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event24
	"This method was automatically generated"
	^handle unsignedCharAt: 24! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event24: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 24 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event25
	"This method was automatically generated"
	^handle unsignedCharAt: 25! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event25: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 25 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event26
	"This method was automatically generated"
	^handle unsignedCharAt: 26! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event26: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 26 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event27
	"This method was automatically generated"
	^handle unsignedCharAt: 27! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event27: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 27 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event28
	"This method was automatically generated"
	^handle unsignedCharAt: 28! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event28: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 28 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event29
	"This method was automatically generated"
	^handle unsignedCharAt: 29! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event29: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 29 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event2: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 2 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event3
	"This method was automatically generated"
	^handle unsignedCharAt: 3! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event30
	"This method was automatically generated"
	^handle unsignedCharAt: 30! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event30: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 30 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event31
	"This method was automatically generated"
	^handle unsignedCharAt: 31! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event31: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 31 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event32
	"This method was automatically generated"
	^handle unsignedCharAt: 32! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event32: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 32 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event3: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 3 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event4
	"This method was automatically generated"
	^handle unsignedCharAt: 4! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event4: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 4 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event5
	"This method was automatically generated"
	^handle unsignedCharAt: 5! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event5: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 5 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event6
	"This method was automatically generated"
	^handle unsignedCharAt: 6! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event6: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 6 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event7
	"This method was automatically generated"
	^handle unsignedCharAt: 7! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event7: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 7 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event8
	"This method was automatically generated"
	^handle unsignedCharAt: 8! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event8: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 8 put: anObject! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event9
	"This method was automatically generated"
	^handle unsignedCharAt: 9! !

!EventBufStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event9: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 9 put: anObject! !

WiiuseStructure subclass: #ExpansionStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!ExpansionStructure commentStamp: 'Richo 11/30/2009 15:51' prior: 0!
/**
 *	@struct expansion_t
 *	@brief Generic expansion device plugged into wiimote.
 */
typedef struct expansion_t {
	int type;						/**< type of expansion attached				*/

	union {
		struct nunchuk_t nunchuk;
		struct classic_ctrl_t classic;
		struct guitar_hero_3_t gh3;
	};
} expansion_t;!

!ExpansionStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/30/2009 15:54'!
fields
"ExpansionStructure defineFields"
	^ #(
	#(#type 'long') 
	#(#nunchuk 'NunchukStructure') 
"	#(#classic 'ClassicCtrlStructure') 
	#(#gh3 'GuitarHero3Structure') "
	)! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 11/30/2009 15:21'!
classic
	"This method was automatically generated"
	^ClassicCtrlStructure fromHandle: (handle structAt: 87 length: 42)! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 11/30/2009 15:21'!
classic: anObject
	"This method was automatically generated"
	handle structAt: 87 put: anObject getHandle length: 42.! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 11/30/2009 15:21'!
gh3
	"This method was automatically generated"
	^GuitarHero3Structure fromHandle: (handle structAt: 129 length: 24)! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 11/30/2009 15:21'!
gh3: anObject
	"This method was automatically generated"
	handle structAt: 129 put: anObject getHandle length: 24.! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
nunchuk
	"This method was automatically generated"
	^NunchukStructure fromHandle: (handle structAt: 5 length: 88)! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
nunchuk: anObject
	"This method was automatically generated"
	handle structAt: 5 put: anObject getHandle length: 88.! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
type
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!ExpansionStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
type: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

WiiuseStructure subclass: #GForceStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!GForceStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 6/1/2008 19:06'!
fields
"GForceStructure defineFields"
	^ #(#(#x 'float') #(#y 'float') #(#z 'float') )! !

!GForceStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x
	"This method was automatically generated"
	^handle floatAt: 1! !

!GForceStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x: anObject
	"This method was automatically generated"
	handle floatAt: 1 put: anObject! !

!GForceStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y
	"This method was automatically generated"
	^handle floatAt: 5! !

!GForceStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y: anObject
	"This method was automatically generated"
	handle floatAt: 5 put: anObject! !

!GForceStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
z
	"This method was automatically generated"
	^handle floatAt: 9! !

!GForceStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
z: anObject
	"This method was automatically generated"
	handle floatAt: 9 put: anObject! !

WiiuseStructure subclass: #GuitarHero3Structure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!GuitarHero3Structure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 17:08'!
fields
"GuitarHero3Structure defineFields"
	^ #(
	#(#btns 'short') 
	#(#btnsHeld 'short') 
	#(#btnsReleased 'short') 
	#(#whammyBar 'float') 
	#(#js 'JoystickStructure') 
	)! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns
	"This method was automatically generated"
	^handle signedShortAt: 1! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns: anObject
	"This method was automatically generated"
	handle signedShortAt: 1 put: anObject! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld
	"This method was automatically generated"
	^handle signedShortAt: 3! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld: anObject
	"This method was automatically generated"
	handle signedShortAt: 3 put: anObject! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased
	"This method was automatically generated"
	^handle signedShortAt: 5! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased: anObject
	"This method was automatically generated"
	handle signedShortAt: 5 put: anObject! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
js
	"This method was automatically generated"
	^JoystickStructure fromHandle: (handle structAt: 11 length: 14)! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
js: anObject
	"This method was automatically generated"
	handle structAt: 11 put: anObject getHandle length: 14.! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
whammyBar
	"This method was automatically generated"
	^handle floatAt: 7! !

!GuitarHero3Structure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
whammyBar: anObject
	"This method was automatically generated"
	handle floatAt: 7 put: anObject! !

WiiuseStructure subclass: #IRDotStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!IRDotStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 12/1/2009 15:46'!
fields
"IRDotStructure defineFields"
	^ #(
	#(#visible 'char') 
	#(#fakeByte1 'byte')
	#(#fakeByte2 'byte')
	#(#fakeByte3 'byte')
	#(#x 'ulong') 
	#(#y 'ulong') 
	#(#rx 'short') 
	#(#ry 'short') 
	#(#order 'char') 
	#(#size 'char')
	#(#fakeByte4 'byte')
	#(#fakeByte5 'byte')
	)! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1
	"This method was automatically generated"
	^handle unsignedByteAt: 2! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 2 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2
	"This method was automatically generated"
	^handle unsignedByteAt: 3! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 3 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3
	"This method was automatically generated"
	^handle unsignedByteAt: 4! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 4 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte4
	"This method was automatically generated"
	^handle unsignedByteAt: 19! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte4: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 19 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte5
	"This method was automatically generated"
	^handle unsignedByteAt: 20! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte5: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 20 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
order
	"This method was automatically generated"
	^handle unsignedCharAt: 17! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
order: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 17 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
rx
	"This method was automatically generated"
	^handle signedShortAt: 13! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
rx: anObject
	"This method was automatically generated"
	handle signedShortAt: 13 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ry
	"This method was automatically generated"
	^handle signedShortAt: 15! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ry: anObject
	"This method was automatically generated"
	handle signedShortAt: 15 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
size
	"This method was automatically generated"
	^handle unsignedCharAt: 18! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
size: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 18 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
visible
	"This method was automatically generated"
	^handle unsignedCharAt: 1! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
visible: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 1 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!IRDotStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

WiiuseStructure subclass: #IRStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!IRStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 12/1/2009 15:48'!
fields
"IRStructure defineFields"
	^ #(
	#(#dot1 'IRDotStructure') 
	#(#dot2 'IRDotStructure') 
	#(#dot3 'IRDotStructure') 
	#(#dot4 'IRDotStructure') 
	#(#numDots 'char')
	#(#fakeByte1 'byte')
	#(#fakeByte2 'byte')
	#(#fakeByte3 'byte')
	#(#aspect 'long') 
	#(#pos 'long') 
	#(#vres1 'ulong') 
	#(#vres2 'ulong') 
	#(#offset1 'long') 
	#(#offset2 'long') 
	#(#state 'long') 
	#(#ax 'long') 
	#(#ay 'long') 
	#(#x 'long') 
	#(#y 'long') 
	#(#distance 'float') 
	#(#z 'float') 
	)! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
aspect
	"This method was automatically generated"
	^handle signedLongAt: 85! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
aspect: anObject
	"This method was automatically generated"
	handle signedLongAt: 85 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ax
	"This method was automatically generated"
	^handle signedLongAt: 113! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ax: anObject
	"This method was automatically generated"
	handle signedLongAt: 113 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ay
	"This method was automatically generated"
	^handle signedLongAt: 117! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ay: anObject
	"This method was automatically generated"
	handle signedLongAt: 117 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
distance
	"This method was automatically generated"
	^handle floatAt: 129! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
distance: anObject
	"This method was automatically generated"
	handle floatAt: 129 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot1
	"This method was automatically generated"
	^IRDotStructure fromHandle: (handle structAt: 1 length: 20)! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot1: anObject
	"This method was automatically generated"
	handle structAt: 1 put: anObject getHandle length: 20.! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot2
	"This method was automatically generated"
	^IRDotStructure fromHandle: (handle structAt: 21 length: 20)! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot2: anObject
	"This method was automatically generated"
	handle structAt: 21 put: anObject getHandle length: 20.! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot3
	"This method was automatically generated"
	^IRDotStructure fromHandle: (handle structAt: 41 length: 20)! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot3: anObject
	"This method was automatically generated"
	handle structAt: 41 put: anObject getHandle length: 20.! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot4
	"This method was automatically generated"
	^IRDotStructure fromHandle: (handle structAt: 61 length: 20)! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
dot4: anObject
	"This method was automatically generated"
	handle structAt: 61 put: anObject getHandle length: 20.! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 4/6/2011 11:25'!
dot: irNumber
^irNumber caseOf: {
	[1] -> [self dot1].
	[2] -> [self dot2].
	[3] -> [self dot3].
	[4] -> [self dot4].
}
otherwise: [WiimoteError signal: 'Invalid ir' translated]! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1
	"This method was automatically generated"
	^handle unsignedByteAt: 82! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 82 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2
	"This method was automatically generated"
	^handle unsignedByteAt: 83! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 83 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3
	"This method was automatically generated"
	^handle unsignedByteAt: 84! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 84 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
numDots
	"This method was automatically generated"
	^handle unsignedCharAt: 81! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
numDots: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 81 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
offset1
	"This method was automatically generated"
	^handle signedLongAt: 101! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
offset1: anObject
	"This method was automatically generated"
	handle signedLongAt: 101 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
offset2
	"This method was automatically generated"
	^handle signedLongAt: 105! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
offset2: anObject
	"This method was automatically generated"
	handle signedLongAt: 105 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
pos
	"This method was automatically generated"
	^handle signedLongAt: 89! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
pos: anObject
	"This method was automatically generated"
	handle signedLongAt: 89 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
state
	"This method was automatically generated"
	^handle signedLongAt: 109! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
state: anObject
	"This method was automatically generated"
	handle signedLongAt: 109 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
vres1
	"This method was automatically generated"
	^handle unsignedLongAt: 93! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
vres1: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 93 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
vres2
	"This method was automatically generated"
	^handle unsignedLongAt: 97! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
vres2: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 97 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x
	"This method was automatically generated"
	^handle signedLongAt: 121! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x: anObject
	"This method was automatically generated"
	handle signedLongAt: 121 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y
	"This method was automatically generated"
	^handle signedLongAt: 125! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y: anObject
	"This method was automatically generated"
	handle signedLongAt: 125 put: anObject! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
z
	"This method was automatically generated"
	^handle floatAt: 133! !

!IRStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
z: anObject
	"This method was automatically generated"
	handle floatAt: 133 put: anObject! !

WiiuseStructure subclass: #JoystickStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!JoystickStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 17:01'!
fields
"JoystickStructure defineFields"
	^ #(
	#(#max 'Vec2bStructure') 
	#(#min 'Vec2bStructure') 
	#(#center 'Vec2bStructure') 
	#(#ang 'float') 
	#(#mag 'float') 
	)! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ang
	"This method was automatically generated"
	^handle floatAt: 7! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ang: anObject
	"This method was automatically generated"
	handle floatAt: 7 put: anObject! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
center
	"This method was automatically generated"
	^Vec2bStructure fromHandle: (handle structAt: 5 length: 2)! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
center: anObject
	"This method was automatically generated"
	handle structAt: 5 put: anObject getHandle length: 2.! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
mag
	"This method was automatically generated"
	^handle floatAt: 11! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
mag: anObject
	"This method was automatically generated"
	handle floatAt: 11 put: anObject! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
max
	"This method was automatically generated"
	^Vec2bStructure fromHandle: (handle structAt: 1 length: 2)! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
max: anObject
	"This method was automatically generated"
	handle structAt: 1 put: anObject getHandle length: 2.! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
min
	"This method was automatically generated"
	^Vec2bStructure fromHandle: (handle structAt: 3 length: 2)! !

!JoystickStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
min: anObject
	"This method was automatically generated"
	handle structAt: 3 put: anObject getHandle length: 2.! !

WiiuseStructure subclass: #NunchukStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!NunchukStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/30/2009 16:23'!
fields
"NunchukStructure defineFields"
	^ #(
	#(#accelCalib 'AccelStructure') 
	#(#js 'JoystickStructure')
	#(#fakeByte1 'byte')
	#(#fakeByte2 'byte')
	#(#flags 'long*') 
	#(#btns 'char') 
	#(#btnsHeld 'char') 
	#(#btnsReleased 'char') 
	#(fakeByte3 'byte')
	#(#orientThreshold 'float') 
	#(#accelThreshold 'long') 
	#(#accel 'Vec3bStructure')
	#(#fakeByte4 'byte')
	#(#orient 'OrientStructure') 
	#(#gforce 'GForceStructure') 
	)! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accel
	"This method was automatically generated"
	^Vec3bStructure fromHandle: (handle structAt: 53 length: 3)! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accel: anObject
	"This method was automatically generated"
	handle structAt: 53 put: anObject getHandle length: 3.! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelCalib
	"This method was automatically generated"
	^AccelStructure fromHandle: (handle structAt: 1 length: 20)! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelCalib: anObject
	"This method was automatically generated"
	handle structAt: 1 put: anObject getHandle length: 20.! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelThreshold
	"This method was automatically generated"
	^handle signedLongAt: 49! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelThreshold: anObject
	"This method was automatically generated"
	handle signedLongAt: 49 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns
	"This method was automatically generated"
	^handle unsignedCharAt: 41! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 41 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld
	"This method was automatically generated"
	^handle unsignedCharAt: 42! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 42 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased
	"This method was automatically generated"
	^handle unsignedCharAt: 43! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 43 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1
	"This method was automatically generated"
	^handle unsignedByteAt: 35! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 35 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2
	"This method was automatically generated"
	^handle unsignedByteAt: 36! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 36 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3
	"This method was automatically generated"
	^handle unsignedByteAt: 44! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 44 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte4
	"This method was automatically generated"
	^handle unsignedByteAt: 56! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte4: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 56 put: anObject! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
flags
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 37) type: ExternalType long asPointerType! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
flags: anObject
	"This method was automatically generated"
	handle pointerAt: 37 put: anObject getHandle.! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
gforce
	"This method was automatically generated"
	^GForceStructure fromHandle: (handle structAt: 77 length: 12)! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
gforce: anObject
	"This method was automatically generated"
	handle structAt: 77 put: anObject getHandle length: 12.! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
js
	"This method was automatically generated"
	^JoystickStructure fromHandle: (handle structAt: 21 length: 14)! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
js: anObject
	"This method was automatically generated"
	handle structAt: 21 put: anObject getHandle length: 14.! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orient
	"This method was automatically generated"
	^OrientStructure fromHandle: (handle structAt: 57 length: 20)! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orient: anObject
	"This method was automatically generated"
	handle structAt: 57 put: anObject getHandle length: 20.! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orientThreshold
	"This method was automatically generated"
	^handle floatAt: 45! !

!NunchukStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orientThreshold: anObject
	"This method was automatically generated"
	handle floatAt: 45 put: anObject! !

WiiuseStructure subclass: #OrientStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!OrientStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 15:41'!
fields
"OrientStructure defineFields"
	^ #(
	#(#roll 'float') 
	#(#pitch 'float') 
	#(#yaw 'float') 
	#(#aRoll 'float') 
	#(#aPitch 'float') 
	)! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
aPitch
	"This method was automatically generated"
	^handle floatAt: 17! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
aPitch: anObject
	"This method was automatically generated"
	handle floatAt: 17 put: anObject! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
aRoll
	"This method was automatically generated"
	^handle floatAt: 13! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
aRoll: anObject
	"This method was automatically generated"
	handle floatAt: 13 put: anObject! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
pitch
	"This method was automatically generated"
	^handle floatAt: 5! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
pitch: anObject
	"This method was automatically generated"
	handle floatAt: 5 put: anObject! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
roll
	"This method was automatically generated"
	^handle floatAt: 1! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
roll: anObject
	"This method was automatically generated"
	handle floatAt: 1 put: anObject! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
yaw
	"This method was automatically generated"
	^handle floatAt: 9! !

!OrientStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
yaw: anObject
	"This method was automatically generated"
	handle floatAt: 9 put: anObject! !

WiiuseStructure subclass: #Vec2bStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!Vec2bStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 17:01'!
fields
"Vec2bStructure defineFields"
	^ #(#(#x 'char') #(#y 'char') )! !

!Vec2bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x
	"This method was automatically generated"
	^handle unsignedCharAt: 1! !

!Vec2bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 1 put: anObject! !

!Vec2bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y
	"This method was automatically generated"
	^handle unsignedCharAt: 2! !

!Vec2bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 2 put: anObject! !

WiiuseStructure subclass: #Vec3bStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!Vec3bStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 16:58'!
fields
"Vec3bStructure defineFields"
	^ #(#(#x 'char') #(#y 'char') #(#z 'char') )! !

!Vec3bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x
	"This method was automatically generated"
	^handle unsignedCharAt: 1! !

!Vec3bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
x: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 1 put: anObject! !

!Vec3bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y
	"This method was automatically generated"
	^handle unsignedCharAt: 2! !

!Vec3bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
y: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 2 put: anObject! !

!Vec3bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
z
	"This method was automatically generated"
	^handle unsignedCharAt: 3! !

!Vec3bStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
z: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 3 put: anObject! !

WiiuseStructure subclass: #WiimoteArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!WiimoteArray methodsFor: 'accessing' stamp: 'Richo 11/9/2009 22:30'!
at: n
	^WiimoteStructure fromHandle: (handle pointerAt: n * 4 - 3)! !

!WiimoteArray methodsFor: 'accessing' stamp: 'Richo 11/9/2009 22:31'!
at: n put: anObject
	handle pointerAt: n * 4 - 3 put: anObject getHandle.! !

!WiimoteArray methodsFor: 'accessing' stamp: 'Richo 11/9/2009 23:37'!
first
^self at: 1! !

!WiimoteArray methodsFor: 'accessing' stamp: 'Richo 11/9/2009 23:37'!
fourth
^self at: 4! !

!WiimoteArray methodsFor: 'accessing' stamp: 'Richo 11/9/2009 23:37'!
second
^self at: 2! !

!WiimoteArray methodsFor: 'accessing' stamp: 'Richo 11/9/2009 23:37'!
third
^self at: 3! !

WiiuseStructure subclass: #WiimoteStateStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!WiimoteStateStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/24/2009 17:19'!
fields
"WiimoteStateStructure defineFields"
	^ #(
	#(#expLjsAng 'float') 
	#(#expRjsAng 'float') 
	#(#expLjsMag 'float') 
	#(#expRjsMag 'float') 
	#(#expBtns 'ushort') 
	#(#expOrient 'OrientStructure') 
	#(#expAccel 'Vec3bStructure') 
	#(#expRShoulder 'float') 
	#(#expLShoulder 'float') 
	#(#irAx 'long') 
	#(#irAy 'long') 
	#(#irDistance 'float') 
	#(#orient 'OrientStructure') 
	#(#btns 'ushort') 
	#(#accel 'Vec3bStructure') 
	)! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accel
	"This method was automatically generated"
	^Vec3bStructure fromHandle: (handle structAt: 84 length: 3)! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accel: anObject
	"This method was automatically generated"
	handle structAt: 84 put: anObject getHandle length: 3.! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns
	"This method was automatically generated"
	^handle unsignedShortAt: 82! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 82 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expAccel
	"This method was automatically generated"
	^Vec3bStructure fromHandle: (handle structAt: 39 length: 3)! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expAccel: anObject
	"This method was automatically generated"
	handle structAt: 39 put: anObject getHandle length: 3.! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expBtns
	"This method was automatically generated"
	^handle unsignedShortAt: 17! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expBtns: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 17 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expLShoulder
	"This method was automatically generated"
	^handle floatAt: 46! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expLShoulder: anObject
	"This method was automatically generated"
	handle floatAt: 46 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expLjsAng
	"This method was automatically generated"
	^handle floatAt: 1! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expLjsAng: anObject
	"This method was automatically generated"
	handle floatAt: 1 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expLjsMag
	"This method was automatically generated"
	^handle floatAt: 9! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expLjsMag: anObject
	"This method was automatically generated"
	handle floatAt: 9 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expOrient
	"This method was automatically generated"
	^OrientStructure fromHandle: (handle structAt: 19 length: 20)! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expOrient: anObject
	"This method was automatically generated"
	handle structAt: 19 put: anObject getHandle length: 20.! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expRShoulder
	"This method was automatically generated"
	^handle floatAt: 42! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expRShoulder: anObject
	"This method was automatically generated"
	handle floatAt: 42 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expRjsAng
	"This method was automatically generated"
	^handle floatAt: 5! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expRjsAng: anObject
	"This method was automatically generated"
	handle floatAt: 5 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expRjsMag
	"This method was automatically generated"
	^handle floatAt: 13! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expRjsMag: anObject
	"This method was automatically generated"
	handle floatAt: 13 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
irAx
	"This method was automatically generated"
	^handle signedLongAt: 50! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
irAx: anObject
	"This method was automatically generated"
	handle signedLongAt: 50 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
irAy
	"This method was automatically generated"
	^handle signedLongAt: 54! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
irAy: anObject
	"This method was automatically generated"
	handle signedLongAt: 54 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
irDistance
	"This method was automatically generated"
	^handle floatAt: 58! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
irDistance: anObject
	"This method was automatically generated"
	handle floatAt: 58 put: anObject! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orient
	"This method was automatically generated"
	^OrientStructure fromHandle: (handle structAt: 62 length: 20)! !

!WiimoteStateStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orient: anObject
	"This method was automatically generated"
	handle structAt: 62 put: anObject getHandle length: 20.! !

WiiuseStructure subclass: #WiimoteStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

!WiimoteStructure class methodsFor: 'field definition' stamp: 'Richo 11/30/2009 16:25'!
fields
	"WiimoteStructure defineFields"
	^ #(
	#(#unid 'long') 
	#(#devHandle 'void *') 
	#(#hidOverlapInternal 'ulong') 
	#(#hidOverlapInternalHigh 'ulong') 
	#(#hidOverlapOffset 'ulong') 
	#(#hidOverlapOffsetHigh 'ulong') 
	#(#hidOverlapHEvent 'void *') 
	#(#stack 'long') 
	#(#timeout 'long') 
	#(#normalTimeout 'char') 
	#(#expTimeout 'char')
	#(#fakeByte1 'byte')
	#(#fakeByte2 'byte')
	#(#state 'long') 
	#(#leds 'char') 
	#(#fakeByte3 'byte')
	#(#fakeByte4 'byte')
	#(#fakeByte5 'byte')
	#(#batteryLevel 'float') 
	#(#flags 'long') 
	#(#handshakeState 'byte') 
	#(#fakeByte6 'byte')
	#(#fakeByte7 'byte')
	#(#fakeByte8 'byte')
	#(#readReq 'void*') 
	#(#accelCalib 'AccelStructure') 
	#(#exp 'ExpansionStructure') 
	#(#accel 'Vec3bStructure') 
	#(#fakeByte9 'byte')
	#(#orient 'OrientStructure') 
	#(#gforce 'GForceStructure') 
	#(#ir 'IRStructure') 
	#(#btns 'ushort') 
	#(#btnsHeld 'ushort') 
	#(#btnsReleased 'ushort') 
	#(#orientThreshold 'float') 
	#(#accelThreshold 'long') 
	#(#lstate 'WiimoteStateStructure') 
	#(#event 'long') 
	#(#eventBuf 'EventBufStructure') )! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accel
	"This method was automatically generated"
	^Vec3bStructure fromHandle: (handle structAt: 177 length: 3)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accel: anObject
	"This method was automatically generated"
	handle structAt: 177 put: anObject getHandle length: 3.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelCalib
	"This method was automatically generated"
	^AccelStructure fromHandle: (handle structAt: 65 length: 20)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelCalib: anObject
	"This method was automatically generated"
	handle structAt: 65 put: anObject getHandle length: 20.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelThreshold
	"This method was automatically generated"
	^handle signedLongAt: 359! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
accelThreshold: anObject
	"This method was automatically generated"
	handle signedLongAt: 359 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
batteryLevel
	"This method was automatically generated"
	^handle floatAt: 49! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
batteryLevel: anObject
	"This method was automatically generated"
	handle floatAt: 49 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns
	"This method was automatically generated"
	^handle unsignedShortAt: 349! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btns: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 349 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld
	"This method was automatically generated"
	^handle unsignedShortAt: 351! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsHeld: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 351 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased
	"This method was automatically generated"
	^handle unsignedShortAt: 353! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
btnsReleased: anObject
	"This method was automatically generated"
	handle unsignedShortAt: 353 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
devHandle
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 5) type: ExternalType void asPointerType! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
devHandle: anObject
	"This method was automatically generated"
	handle pointerAt: 5 put: anObject getHandle.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event
	"This method was automatically generated"
	^handle signedLongAt: 449! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
event: anObject
	"This method was automatically generated"
	handle signedLongAt: 449 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
eventBuf
	"This method was automatically generated"
	^EventBufStructure fromHandle: (handle structAt: 453 length: 32)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
eventBuf: anObject
	"This method was automatically generated"
	handle structAt: 453 put: anObject getHandle length: 32.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
exp
	"This method was automatically generated"
	^ExpansionStructure fromHandle: (handle structAt: 85 length: 92)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
exp: anObject
	"This method was automatically generated"
	handle structAt: 85 put: anObject getHandle length: 92.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expTimeout
	"This method was automatically generated"
	^handle unsignedCharAt: 38! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
expTimeout: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 38 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1
	"This method was automatically generated"
	^handle unsignedByteAt: 39! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 11/30/2009 16:10'!
fakeByte10
	"This method was automatically generated"
	^handle unsignedCharAt: 86! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 11/30/2009 16:10'!
fakeByte10: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 86 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte1: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 39 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2
	"This method was automatically generated"
	^handle unsignedByteAt: 40! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte2: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 40 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3
	"This method was automatically generated"
	^handle unsignedByteAt: 46! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte3: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 46 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte4
	"This method was automatically generated"
	^handle unsignedByteAt: 47! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte4: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 47 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte5
	"This method was automatically generated"
	^handle unsignedByteAt: 48! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte5: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 48 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte6
	"This method was automatically generated"
	^handle unsignedByteAt: 58! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte6: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 58 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte7
	"This method was automatically generated"
	^handle unsignedByteAt: 59! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte7: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 59 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte8
	"This method was automatically generated"
	^handle unsignedByteAt: 60! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte8: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 60 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte9
	"This method was automatically generated"
	^handle unsignedByteAt: 180! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
fakeByte9: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 180 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
flags
	"This method was automatically generated"
	^handle signedLongAt: 53! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
flags: anObject
	"This method was automatically generated"
	handle signedLongAt: 53 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
gforce
	"This method was automatically generated"
	^GForceStructure fromHandle: (handle structAt: 201 length: 12)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
gforce: anObject
	"This method was automatically generated"
	handle structAt: 201 put: anObject getHandle length: 12.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
handshakeState
	"This method was automatically generated"
	^handle unsignedByteAt: 57! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
handshakeState: anObject
	"This method was automatically generated"
	handle unsignedByteAt: 57 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 11/10/2009 00:09'!
hidOverlap
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 9) type: ExternalType void asPointerType! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 11/10/2009 00:09'!
hidOverlap: anObject
	"This method was automatically generated"
	handle pointerAt: 9 put: anObject getHandle.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapHEvent
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 25) type: ExternalType void asPointerType! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapHEvent: anObject
	"This method was automatically generated"
	handle pointerAt: 25 put: anObject getHandle.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapInternal
	"This method was automatically generated"
	^handle unsignedLongAt: 9! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapInternal: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 9 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapInternalHigh
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapInternalHigh: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapOffset
	"This method was automatically generated"
	^handle unsignedLongAt: 17! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapOffset: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 17 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapOffsetHigh
	"This method was automatically generated"
	^handle unsignedLongAt: 21! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
hidOverlapOffsetHigh: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 21 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ir
	"This method was automatically generated"
	^IRStructure fromHandle: (handle structAt: 213 length: 136)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
ir: anObject
	"This method was automatically generated"
	handle structAt: 213 put: anObject getHandle length: 136.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
leds
	"This method was automatically generated"
	^handle unsignedCharAt: 45! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
leds: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 45 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
lstate
	"This method was automatically generated"
	^WiimoteStateStructure fromHandle: (handle structAt: 363 length: 86)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
lstate: anObject
	"This method was automatically generated"
	handle structAt: 363 put: anObject getHandle length: 86.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
normalTimeout
	"This method was automatically generated"
	^handle unsignedCharAt: 37! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
normalTimeout: anObject
	"This method was automatically generated"
	handle unsignedCharAt: 37 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orient
	"This method was automatically generated"
	^OrientStructure fromHandle: (handle structAt: 181 length: 20)! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orient: anObject
	"This method was automatically generated"
	handle structAt: 181 put: anObject getHandle length: 20.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orientThreshold
	"This method was automatically generated"
	^handle floatAt: 355! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
orientThreshold: anObject
	"This method was automatically generated"
	handle floatAt: 355 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
readReq
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 61) type: ExternalType void asPointerType! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
readReq: anObject
	"This method was automatically generated"
	handle pointerAt: 61 put: anObject getHandle.! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stack
	"This method was automatically generated"
	^handle signedLongAt: 29! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
stack: anObject
	"This method was automatically generated"
	handle signedLongAt: 29 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
state
	"This method was automatically generated"
	^handle signedLongAt: 41! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
state: anObject
	"This method was automatically generated"
	handle signedLongAt: 41 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
timeout
	"This method was automatically generated"
	^handle signedLongAt: 33! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
timeout: anObject
	"This method was automatically generated"
	handle signedLongAt: 33 put: anObject! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
unid
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!WiimoteStructure methodsFor: 'accessing' stamp: 'Richo 12/1/2009 16:01'!
unid: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!WiiuseStructure class methodsFor: 'as yet unclassified' stamp: 'Richo 11/25/2009 12:37'!
defineAllFields
self allSubclassesDo: [:each | each defineFields]! !

!WiiuseStructure methodsFor: 'accessing' stamp: 'Richo 11/25/2009 14:33'!
bytes

^ (1 to: (self fieldSizeOf: self class asString)) collect: [:i| handle byteAt: i].! !

!WiiuseStructure methodsFor: 'nil' stamp: 'Richo 11/25/2009 14:17'!
fieldSizeOf: aString

		| isPointerField fieldType externalType selfRefering |
		isPointerField := aString last = $*.
		fieldType := (aString findTokens: ' *') first.
		externalType := ExternalType atomicTypeNamed: fieldType.
		selfRefering := externalType == nil and: fieldType = self asString and: isPointerField.
		selfRefering ifTrue: [
			externalType := ExternalType void asPointerType
		] ifFalse:[
			externalType == nil ifTrue: ["non-atomic"
				Symbol
					hasInterned: fieldType
					ifTrue: [:sym | externalType := ExternalType structTypeNamed: sym].
			].
			externalType == nil ifTrue:[
				Transcript show: '(' , fieldType , ' is void)'.
				externalType := ExternalType void.
			].
			isPointerField ifTrue: [externalType := externalType asPointerType]].
			^externalType byteSize.! !

!WiiuseStructure methodsFor: 'printing' stamp: 'Richo 11/25/2009 16:27'!
longPrintOn: aStream indentationLevel: indLevel
	"Append to the argument, aStream, the names and values of all the record's variables."
	| index fieldSize bytes fieldName fieldValue fieldType |
	index := 0.
	self class fields do: [ :field | 
			fieldName := field first.
			fieldValue := (self perform: fieldName).
			fieldValue isCharacter ifTrue: [fieldValue := fieldValue asInteger].
			fieldType :=field second.
			fieldSize := self fieldSizeOf: fieldType.
			bytes := (1 to: fieldSize) collect: [:i| handle byteAt: index + i].
			index := index + fieldSize.
			indLevel timesRepeat: [aStream tab].
			aStream nextPutAll: fieldName; nextPut: $:; space; tab.
			(fieldValue isKindOf: WiiuseStructure)
				ifTrue: [
					aStream nextPutAll: '{', fieldType, '}'; "tab.
					bytes printOn: aStream.
					aStream" cr. 
					fieldValue longPrintOn: aStream indentationLevel: indLevel + 1]
				ifFalse: [
					fieldValue printOn: aStream. 
					aStream tab; nextPutAll: '{', fieldType,'}'.
					aStream tab.
					bytes printOn: aStream.
					].			
			aStream cr].! !

!WiiuseStructure methodsFor: 'printing' stamp: 'Richo 11/25/2009 16:27'!
longPrintString
	"Append to the argument, aStream, the names and values of all the record's variables."
| w |
w := WriteStream on: ''.
self longPrintOn: w indentationLevel: 0.
^w contents.! !

Error subclass: #WiimoteError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-Errors'!

Object subclass: #Wiimote
	instanceVariableNames: 'wiimoteStruct'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-Core'!

Wiimote class
	instanceVariableNames: 'connectedInstances'!

Wiimote class
	instanceVariableNames: 'connectedInstances'!

!Wiimote class methodsFor: 'connected instances' stamp: 'Richo 12/1/2009 10:48'!
addToConnectedInstancesList: aWiimote
connectedInstances add: aWiimote! !

!Wiimote class methodsFor: 'class initialization' stamp: 'Richo 4/6/2011 15:53'!
initialize
"Wiimote initialize"
connectedInstances := Set new.
Smalltalk addToShutDownList: self.! !

!Wiimote class methodsFor: 'connected instances' stamp: 'Richo 4/6/2011 11:25'!
removeFromConnectedInstancesList: aWiimote
"Si no hay ms instancias conectadas, desconecto todo"
connectedInstances 
	remove: aWiimote 
	ifAbsent: [^WiimoteError signal: 'Wiimote not connected' translated].
connectedInstances isEmpty 
	ifTrue: [Wiiuse disconnectAll]! !

!Wiimote class methodsFor: 'class initialization' stamp: 'Richo 12/1/2009 13:06'!
shutDown
connectedInstances asArray do: [:each| each disconnect]! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 17:28'!
accelX
	self controlConnection.
	^Wiiuse accelXOf: wiimoteStruct! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 17:29'!
accelY
	self controlConnection.
	^Wiiuse accelYOf: wiimoteStruct! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 17:29'!
accelZ
	self controlConnection.
	^Wiiuse accelZOf: wiimoteStruct! !

!Wiimote methodsFor: 'battery level' stamp: 'Richo 12/1/2009 13:44'!
batteryLevel
	self controlConnection.
	^wiimoteStruct batteryLevel * 100! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:13'!
buttonA
^self isPressed: #a! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:13'!
buttonB
^self isPressed: #b! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:13'!
buttonDown
^self isPressed: #down! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:14'!
buttonHome
^self isPressed: #home! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:13'!
buttonLeft
^self isPressed: #left! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:14'!
buttonMinus
^self isPressed: #minus! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:14'!
buttonOne
^self isPressed: #one! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:14'!
buttonPlus
^self isPressed: #plus! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:13'!
buttonRight
^self isPressed: #right! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:14'!
buttonTwo
^self isPressed: #two! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:13'!
buttonUp
^self isPressed: #up! !

!Wiimote methodsFor: 'connection' stamp: 'Richo 4/6/2011 11:26'!
connect: aNumber
self isConnected ifTrue: [^WiimoteError signal: 'Already connected' translated].
Wiiuse findAndConnect.
wiimoteStruct := Wiiuse wiimoteAt: aNumber.
self class addToConnectedInstancesList: self.
self flashLedsAndRumble.
self led: aNumber state: true.
! !

!Wiimote methodsFor: 'control' stamp: 'Richo 4/6/2011 10:41'!
controlConnection
	"This method should be called at the beginning of almost every method of this class. 
	Otherwise we could end up passing nil to an api function, thus crashing the VM"
	self isConnected ifFalse: [WiimoteError signal: 'Wiimote not connected' translated]! !

!Wiimote methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:46'!
disconnect 
	self controlConnection.
	self rumble: false.
	self turnOffAllLeds.

	"Wiiuse disconnect: wiimoteStruct."
	wiimoteStruct := nil.
	self class removeFromConnectedInstancesList: self.
! !

!Wiimote methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:53'!
flashLedsAndRumble
| delay |
delay := (Delay forMilliseconds: 25).
self rumble: true.
#(1 2 3 4 3 2 1) do: [:i|
	self turnOffAllLeds.
	self led: i state: true.
	delay wait].
self turnOffAllLeds.
self rumble: false! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:41'!
irSensitivity
	self controlConnection.
	^Wiiuse irSensitivityOf: wiimoteStruct! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:41'!
irSensitivity: aNumber
	self controlConnection.
	^Wiiuse irSensitivity: aNumber of: wiimoteStruct! !

!Wiimote methodsFor: 'connection' stamp: 'Richo 12/1/2009 10:30'!
isConnected
^wiimoteStruct notNil! !

!Wiimote methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:15'!
isPressed: buttonName
self controlConnection.
^Wiiuse isPressed: buttonName of: wiimoteStruct! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 12:15'!
isUsingAccelerometer
	self controlConnection.
	^Wiiuse isUsingAccelerometer: wiimoteStruct ! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:14'!
isUsingIR
	self controlConnection.
	^Wiiuse isUsingIR: wiimoteStruct ! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:07'!
isVisibleIR: irNumber
	self controlConnection.
	^Wiiuse isVisibleIR: irNumber of: wiimoteStruct! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:24'!
led1
	^self led: 1! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:23'!
led1: aBoolean
	self led: 1 state: aBoolean! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:24'!
led2
	^self led: 2! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:23'!
led2: aBoolean
	self led: 2 state: aBoolean! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:24'!
led3
	^self led: 3! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:23'!
led3: aBoolean
	self led: 3 state: aBoolean! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:24'!
led4
	^self led: 4! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:24'!
led4: aBoolean
	self led: 4 state: aBoolean! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:24'!
led: ledNumber
	self controlConnection.
	^Wiiuse isLedOn: ledNumber of: wiimoteStruct! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:23'!
led: ledNumber state: aBoolean
	self controlConnection.
	aBoolean 
		ifTrue: [Wiiuse turnOnLed: ledNumber of: wiimoteStruct]
		ifFalse: [Wiiuse turnOffLed: ledNumber of: wiimoteStruct]! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 12:16'!
pitch
	self controlConnection.
	^wiimoteStruct orient pitch! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 12:16'!
roll
	self controlConnection.
	^wiimoteStruct orient roll! !

!Wiimote methodsFor: 'rumble' stamp: 'Richo 12/1/2009 14:58'!
rumble
	self controlConnection.
	^Wiiuse isRumbling: wiimoteStruct! !

!Wiimote methodsFor: 'rumble' stamp: 'Richo 12/1/2009 12:45'!
rumble: aBoolean
	self controlConnection.
	Wiiuse setRumble: aBoolean of: wiimoteStruct! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/2/2009 14:43'!
sizeIR: irNumber
	self controlConnection.
	^Wiiuse sizeIR: irNumber of: wiimoteStruct! !

!Wiimote methodsFor: 'private' stamp: 'Richo 12/1/2009 13:01'!
struct
"Just for testing DO NOT USE!!"
^wiimoteStruct! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:43'!
toggleLed1
	self controlConnection.
	Wiiuse toggleLed: 1 of: wiimoteStruct
 ! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:43'!
toggleLed2
	self controlConnection.
	Wiiuse toggleLed: 2 of: wiimoteStruct
 ! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:44'!
toggleLed3
	self controlConnection.
	Wiiuse toggleLed: 3 of: wiimoteStruct
 ! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:44'!
toggleLed4
	self controlConnection.
	Wiiuse toggleLed: 4 of: wiimoteStruct
 ! !

!Wiimote methodsFor: 'rumble' stamp: 'Richo 12/1/2009 12:45'!
toggleRumble
	self controlConnection.
	Wiiuse toggleRumbleOf: wiimoteStruct! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:38'!
turnOffAllLeds
	self controlConnection.
	Wiiuse turnOffAllLedsOf: wiimoteStruct! !

!Wiimote methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:38'!
turnOnAllLeds
	self controlConnection.
	Wiiuse turnOnAllLedsOf: wiimoteStruct! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 12:16'!
useAccelerometer: aBoolean
	self controlConnection.
	Wiiuse motionSensing: wiimoteStruct status: aBoolean! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:14'!
useIR: aBoolean
	self controlConnection.
	Wiiuse setIR: wiimoteStruct status: aBoolean! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:07'!
xIR: irNumber
	self controlConnection.
	^Wiiuse xIR: irNumber of: wiimoteStruct! !

!Wiimote methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:08'!
yIR: irNumber
	self controlConnection.
	^Wiiuse yIR: irNumber of: wiimoteStruct! !

!Wiimote methodsFor: 'orientation' stamp: 'Richo 12/1/2009 12:16'!
yaw
	self controlConnection.
	^wiimoteStruct orient yaw! !

Object subclass: #Wiiuse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Wiimote-FFI'!

Wiiuse class
	instanceVariableNames: 'pollingThread wiimotes connected'!

Wiiuse class
	instanceVariableNames: 'pollingThread wiimotes connected'!

!Wiiuse class methodsFor: 'acceleration' stamp: 'Richo 12/1/2009 17:28'!
accelXOf: aWiimoteStructure
^aWiimoteStructure accel x asInteger! !

!Wiiuse class methodsFor: 'acceleration' stamp: 'Richo 12/1/2009 17:29'!
accelYOf: aWiimoteStructure
^aWiimoteStructure accel y asInteger! !

!Wiiuse class methodsFor: 'acceleration' stamp: 'Richo 12/1/2009 17:29'!
accelZOf: aWiimoteStructure
^aWiimoteStructure accel z asInteger! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:29'!
apiCleanUp: wiimotes cant: aNumber 
	<apicall: short 'wiiuse_cleanup' (WiimoteArray* short) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiConnect: wiimotes cant: aNumber 
	<apicall: short 'wiiuse_connect' (WiimoteArray* short) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiDisconnect: wiimote
	<apicall: void 'wiiuse_disconnect' (WiimoteStructure*) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiDisconnected: wiimote
	<apicall: void 'wiiuse_disconnected' (WiimoteStructure*) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiFind: wiimotes cant: aNumber duration: seconds 
	<apicall: short 'wiiuse_find' (WiimoteArray* short short) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiInit: aNumber 
	<apicall: WiimoteArray* 'wiiuse_init' (short) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiMotionSensing: wiimote status: aNumber 
	<apicall: void 'wiiuse_motion_sensing' (WiimoteStructure* long) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiPoll: wiimotes cant: aNumber 
	<apicall: short 'wiiuse_poll' (WiimoteArray* short) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiReadData: wiimote buffer: buffer offset: offset len: len 
	<apicall: long 'wiiuse_read_data' (WiimoteStructure* byte* ulong ushort) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiRumble: wiimote status: aNumber
	<apicall: void 'wiiuse_rumble' (WiimoteStructure* long) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 12/1/2009 17:10'!
apiSetIR: wiimote status: aNumber 
"WIIUSE_EXPORT extern void wiiuse_set_ir(struct wiimote_t* wm, int status);"
	<apicall: void 'wiiuse_set_ir' (WiimoteStructure* long) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 12/1/2009 17:37'!
apiSetIRSensitivity: wiimote level: aNumber 
"WIIUSE_EXPORT extern void wiiuse_set_ir_sensitivity(struct wiimote_t* wm, int level);"
	<apicall: void 'wiiuse_set_ir_sensitivity' (WiimoteStructure* long) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiSetLeds: wiimote leds: aNumber 
	<apicall: void 'wiiuse_set_leds' (WiimoteStructure* long) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiStatus: wiimote 
	<apicall: void 'wiiuse_status' (WiimoteStructure*) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiToggleRumble: wiimote 
	<apicall: void 'wiiuse_toggle_rumble' (WiimoteStructure*) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'api functions' stamp: 'Richo 11/30/2009 17:30'!
apiWriteData: wiimote addr: addr data: data len: len 
	<apicall: long 'wiiuse_write_data' (WiimoteStructure* ulong byte* byte) module: 'wiiuse.dll'>
	^ self externalCallFailed! !

!Wiiuse class methodsFor: 'battery level' stamp: 'Richo 12/1/2009 10:25'!
batteryLevelOf: aWiimoteStructure

^aWiimoteStructure batteryLevel! !

!Wiiuse class methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:12'!
buttonCodeFor: buttonName
	^buttonName
		caseOf: {
			[#two] -> [16r1].
			[#one] -> [16r2].
			[#b] -> [16r4].
			[#a] -> [16r8].
			[#minus] -> [16r10].
			[#home] -> [16r80].
			[#left] -> [16r100].
			[#right] -> [16r200].
			[#down] -> [16r400].
			[#up] -> [16r800].
			[#plus] -> [16r1000].
		}
		otherwise: [16r8000]! !

!Wiiuse class methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:50'!
disconnect: aWiimoteStructure
"What if aWiimoteStructure is not connected?
Obsolete - Now we simply use #disconnectAll when necessary"
self apiDisconnect: aWiimoteStructure! !

!Wiiuse class methodsFor: 'connection' stamp: 'Richo 12/1/2009 14:51'!
disconnectAll
	"Beware!! Do not call if you have nothing to clean up, or you could crash the vm."
	self stopPolling.
	self apiCleanUp: wiimotes cant: self maxWiimotes.! !

!Wiiuse class methodsFor: 'connection' stamp: 'Richo 4/6/2011 11:26'!
findAndConnect
"Conecta todos los wiimotes que encuentra, empieza el proceso de polling y devuelve el nmero de wiimotes conectados."

wiimotes := self apiInit: self maxWiimotes.
(self apiFind: wiimotes cant: self maxWiimotes duration: 5) = 0
ifTrue: [^WiimoteError signal: 'No wiimotes found' translated].
 
connected := (self apiConnect: wiimotes cant: self maxWiimotes).
connected = 0
ifTrue: [^WiimoteError signal: 'No wiimotes connected' translated].
	
self startPolling.
^connected! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:38'!
irSensitivity: level of: aWiimoteStructure
self apiSetIRSensitivity: aWiimoteStructure level: (level min: 5 max: 1)! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:35'!
irSensitivityOf: aWiimoteStructure
"#define WIIUSE_GET_IR_SENSITIVITY(dev, lvl)									\
			do {														\
				if ((wm->state & 0x0200) == 0x0200) 		*lvl = 1;	\
				else if ((wm->state & 0x0400) == 0x0400) 	*lvl = 2;	\
				else if ((wm->state & 0x0800) == 0x0800) 	*lvl = 3;	\
				else if ((wm->state & 0x1000) == 0x1000) 	*lvl = 4;	\
				else if ((wm->state & 0x2000) == 0x2000) 	*lvl = 5;	\
				else									*lvl = 0;		\
			} while (0)"
| state |
state := aWiimoteStructure state.
(state bitAnd: 16r0200) = 16r0200 ifTrue: [^1].
(state bitAnd: 16r0400) = 16r0400 ifTrue: [^2].
(state bitAnd: 16r0800) = 16r0800 ifTrue: [^3].
(state bitAnd: 16r1000) = 16r1000 ifTrue: [^4].
(state bitAnd: 16r2000) = 16r2000 ifTrue: [^5].
^0! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 12/1/2009 11:37'!
isLedOn: ledNumber of: aWiimoteStructure
	| ledCode |
	ledCode := (self ledCodeFor: ledNumber).
	^(aWiimoteStructure leds asInteger bitAnd: ledCode) = ledCode ! !

!Wiiuse class methodsFor: 'buttons' stamp: 'Richo 12/1/2009 15:09'!
isPressed: buttonName of: aWiimoteStructure
	"#define IS_PRESSED(dev, button)		((dev->btns & button) == button)"
	| buttonCode |
	buttonCode := self buttonCodeFor: buttonName.
	^(aWiimoteStructure btns bitAnd: buttonCode) = buttonCode! !

!Wiiuse class methodsFor: 'orientation' stamp: 'Richo 12/1/2009 14:58'!
isRumbling: aWiimoteStructure
^(aWiimoteStructure state bitAnd: 16r10) = 16r10! !

!Wiiuse class methodsFor: 'orientation' stamp: 'Richo 12/1/2009 10:23'!
isUsingAccelerometer: aWiimoteStructure
"#define WIIUSE_USING_ACC(wm)			((wm->state & 0x020) == 0x020)"
^(aWiimoteStructure state bitAnd: 16r20) = 16r20! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:12'!
isUsingIR: aWiimoteStructure
"#define WIIUSE_USING_IR(wm)				((wm->state & 0x080) == 0x080)"
	^(aWiimoteStructure state bitAnd: 16r80) = 16r80! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:22'!
isVisibleIR: irNumber of: aWiimoteStructure
^(aWiimoteStructure ir dot: irNumber) visible asInteger = 1! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 4/6/2011 11:26'!
ledCodeFor: ledNumber
^ledNumber 
	caseOf: {
		[1] -> [self wiimoteLed1].
		[2] -> [self wiimoteLed2].
		[3] -> [self wiimoteLed3].
		[4] -> [self wiimoteLed4]
	}
	otherwise: [WiimoteError signal: 'Invalid led' translated]! !

!Wiiuse class methodsFor: 'constants' stamp: 'Richo 11/30/2009 17:23'!
maxWiimotes
^4! !

!Wiiuse class methodsFor: 'orientation' stamp: 'Richo 12/1/2009 10:33'!
motionSensing: aWiimoteStructure status: aBoolean
self apiMotionSensing: aWiimoteStructure status: (aBoolean ifTrue: [1] ifFalse: [0])! !

!Wiiuse class methodsFor: 'orientation' stamp: 'Richo 12/1/2009 10:23'!
pitchOf: aWiimoteStructure

^aWiimoteStructure orient pitch! !

!Wiiuse class methodsFor: 'orientation' stamp: 'Richo 12/1/2009 10:23'!
rollOf: aWiimoteStructure

^aWiimoteStructure orient roll! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:13'!
setIR: aWiimoteStructure status: aBoolean
self apiSetIR: aWiimoteStructure status: (aBoolean ifTrue: [1] ifFalse: [0])! !

!Wiiuse class methodsFor: 'rumble' stamp: 'Richo 12/1/2009 12:45'!
setRumble: aBoolean of: aWiimoteStructure
self apiRumble: aWiimoteStructure status: (aBoolean ifTrue: [1] ifFalse: [0])! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/2/2009 14:41'!
sizeIR: irNumber of: aWiimoteStructure
^(aWiimoteStructure ir dot: irNumber) size asInteger! !

!Wiiuse class methodsFor: 'polling thread' stamp: 'Richo 2/19/2010 15:37'!
startPolling
| delay |
self stopPolling.
delay := 5 milliSeconds asDelay.
pollingThread := [[self apiPoll: wiimotes cant: self maxWiimotes. delay wait] repeat] forkNamed: 'Wiiuse polling thread'.! !

!Wiiuse class methodsFor: 'polling thread' stamp: 'Richo 11/30/2009 17:31'!
stopPolling
pollingThread ifNotNilDo: [:p | p terminate].
pollingThread := nil! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:01'!
toggleLed: ledNumber of: aWiimoteStructure
	| current mask |
	current := aWiimoteStructure leds asInteger.
	mask := self ledCodeFor: ledNumber.
	self apiSetLeds: aWiimoteStructure leds: (current bitXor: mask)! !

!Wiiuse class methodsFor: 'rumble' stamp: 'Richo 12/1/2009 10:22'!
toggleRumbleOf: aWiimoteStructure
self apiToggleRumble: aWiimoteStructure! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:37'!
turnOffAllLedsOf: aWiimoteStructure
	self apiSetLeds: aWiimoteStructure leds: 16r00! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 12/1/2009 11:59'!
turnOffLed: ledNumber of: aWiimoteStructure
	| current mask |
	current := aWiimoteStructure leds asInteger.
	mask := (self ledCodeFor: ledNumber).
	self apiSetLeds: aWiimoteStructure leds: (current bitOr: mask) - mask! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 12/1/2009 12:37'!
turnOnAllLedsOf: aWiimoteStructure
	self apiSetLeds: aWiimoteStructure leds: 16rF0! !

!Wiiuse class methodsFor: 'leds' stamp: 'Richo 12/1/2009 11:59'!
turnOnLed: ledNumber of: aWiimoteStructure
	| current mask |
	current := aWiimoteStructure leds asInteger.
	mask := (self ledCodeFor: ledNumber).
	self apiSetLeds: aWiimoteStructure leds: (current bitOr: mask)  ! !

!Wiiuse class methodsFor: 'accessing' stamp: 'Richo 4/6/2011 11:26'!
wiimoteAt: aNumber
(aNumber between: 1 and: connected)
ifFalse: [^WiimoteError signal: 'Wiimote not found' translated].
^wiimotes at: aNumber! !

!Wiiuse class methodsFor: 'constants' stamp: 'Richo 11/30/2009 17:23'!
wiimoteLed1
^16r10! !

!Wiiuse class methodsFor: 'constants' stamp: 'Richo 11/30/2009 17:23'!
wiimoteLed2
^16r20! !

!Wiiuse class methodsFor: 'constants' stamp: 'Richo 11/30/2009 17:24'!
wiimoteLed3
^16r40! !

!Wiiuse class methodsFor: 'constants' stamp: 'Richo 11/30/2009 17:24'!
wiimoteLed4
^16r80! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:21'!
xIR: irNumber of: aWiimoteStructure
^(aWiimoteStructure ir dot: irNumber) x! !

!Wiiuse class methodsFor: 'ir' stamp: 'Richo 12/1/2009 17:21'!
yIR: irNumber of: aWiimoteStructure
^(aWiimoteStructure ir dot: irNumber) y! !

!Wiiuse class methodsFor: 'orientation' stamp: 'Richo 12/1/2009 10:24'!
yawOf:aWiimoteStructure

^aWiimoteStructure orient yaw! !
Wiimote initialize!
